-module(arbre).
-compile(export_all).

arbreVide() ->
    {arbre}.

arbreCons(Elem, Ag, Ad) ->
    {arbre, 1 + max(hauteur(Ag), hauteur(Ad)), Elem, Ag, Ad}.
    
racine({arbre, _, Elem, _, _}) ->
    Elem ;
racine({arbre}) ->
    errorVide.

arbreDroit({arbre, _, _, _, Ad}) ->
    Ad ;
arbreDroit({arbre}) ->
    errorVide.

arbreGauche({arbre, _, _, Ag, _}) ->
    Ag ;
arbreGauche({arbre}) ->
    errorVide.

arbreEstVide({arbre}) ->
    true ;
arbreEstVide({arbre, _, _, _, _}) ->
    false.

arbreEstFeuille(A) ->
    not(arbreEstVide(A)) andalso arbreEstVide(arbreGauche(A)) andalso arbreEstVide(arbreDroit(A)).

hauteur(A) ->
    case arbreEstVide(A) of
	true ->
	    0 ;
	false ->
	    {arbre, H, _, _, _} = A,
	    H
    end.

feuille(E) ->
    arbreCons(E, arbreVide(), arbreVide()).
