-module(tp08).

-export( [ main1/0, main2/0 ] ).

-import(arbre, [ arbreVide/0, arbreCons/3, racine/1, arbreGauche/1, arbreDroit/1, arbreEstVide/1, arbreEstFeuille/1, hauteur/1, feuille/1 ]).

comptage(A, Min, Max) ->
    case arbreEstVide(A) of 
	true ->
	    0;
	false ->
	    case Max < racine(A) of
		true ->
		    comptage(arbreGauche(A), Min, Max);
		false ->
		    case racine(A) < Min of
			true ->
			    comptage(arbreDroit(A), Min, Max);
			false ->
			    comptage(arbreGauche(A), Min, Max) + 1 + comptage(arbreDroit(A), Min, Max)
		    end
	    end
    end.

main1() ->
    A = arbreCons(55,feuille(23),feuille(65)),
    comptage(A, 40, 105).

addPoint({X, Y}, A, Vertical) ->
    case arbre:arbreEstVide(A) of 
	true ->
	    arbre:arbreCons( {X, Y}, arbre:arbreVide(), arbre:arbreVide()) ;
	false ->
	    { RX , RY } = arbre:racine(A), 
	    case Vertical of 
		true ->
		    case X =< RX of
			true ->
			    arbre:arbreCons(arbre:racine(A), addPoint({X, Y}, arbre:arbreGauche(A), false), arbre:arbreDroit(A)) ;
			false ->
			    arbre:arbreCons(arbre:racine(A), arbre:arbreGauche(A), addPoint({X, Y}, arbre:arbreDroit(A), false)) 
		    end ;
		false ->
		    case Y =< RY of
			true ->
			    arbre:arbreCons(arbre:racine(A), addPoint({X, Y}, arbre:arbreGauche(A), true), arbre:arbreDroit(A)) ;
			false ->
			    arbre:arbreCons(arbre:racine(A), arbre:arbreGauche(A), addPoint({X, Y}, arbre:arbreDroit(A), true)) 
		    end 
	    end
    end.

print(Canevas, {X1, Y1, X2, Y2}, A, Vertical) ->
    case arbre:arbreEstVide(A) of
	true ->
	    Canevas ;
	false ->
	    { X, Y } = arbre:racine(A),
	    case Vertical of 
		true ->
		    D = print( draw:add( draw:line(X, Y1, X, Y2), draw:add( draw:circle(X, Y, 5), Canevas)), { X1, Y1, X, Y2 }, arbre:arbreGauche(A), false),
		    print(D, { X, Y1, X2, Y2 }, arbre:arbreDroit(A), false) ;
		false ->
		    D = print( draw:add( draw:line(X1, Y, X2, Y), draw:add( draw:circle(X, Y, 5), Canevas)), { X1, Y1, X2, Y }, arbre:arbreGauche(A), true),
		    print(D, { X1, Y, X2, Y2 }, arbre:arbreDroit(A), true)
	    end
    end.

printSimple(Canevas, A) ->
    case arbre:arbreEstVide(A) of
	true ->
	    Canevas ;
	false ->
	    { X, Y } = arbre:racine(A),
	    case Vertical of 
		true ->
		    D = printSimple( draw:add(draw:circle(X, Y, 5), Canevas), arbre:arbreGauche(A)),
		    printSimple(D, arbre:arbreDroit(A)) ;
		false ->
		    D = printSimple( draw:add(draw:circle(X, Y, 5), Canevas), arbre:arbreGauche(A)),
		    printSimple(D, arbre:arbreDroit(A))
	    end
    end.

nbPoints({X1, Y1, X2, Y2}, A, Vertical) ->
    case arbre:arbreEstVide(A) of
	true ->
	    0;
	false ->
	    { X, Y } = arbre:racine(A),
	    case (X1 =< X) andalso (X =< X2) andalso (Y1 =< Y) andalso (Y =< Y2) of
		true ->
		    1 + nbPoints({X1, Y1, X2, Y2}, arbre:arbreGauche(A), not(Vertical))
			+ nbPoints({X1, Y1, X2, Y2}, arbre:arbreDroit(A), not(Vertical)) ;
		false ->
		    case Vertical of 
			true ->
			    case X =< X1 of
				true ->
				    nbPoints({X1, Y1, X2, Y2}, arbre:arbreDroit(A), not(Vertical)) ;
				false ->
				    nbPoints({X1, Y1, X2, Y2}, arbre:arbreGauche(A), not(Vertical))
			    end ;
			false ->
			    case Y =< Y1 of
				true ->
				    nbPoints({X1, Y1, X2, Y2}, arbre:arbreDroit(A), not(Vertical)) ;
				false ->
				    nbPoints({X1, Y1, X2, Y2}, arbre:arbreGauche(A), not(Vertical))
			    end 
		    end
	    end
    end.


main2() ->
    A = addPoint({120, 180},
		 addPoint({320, 160},
			  addPoint({110, 150}, 
				   addPoint({40, 100},
					    arbre:arbreVide(), true),
				   true),
			  true),
		 true),

    Size = 400,
    Contour = draw:pathLineTo(0, 0, draw:pathLineTo(Size, 0, draw:pathLineTo(Size, Size, draw:pathLineTo(0, Size, draw:path(0,0))))),
    Rect = {100, 100, 250, 250},
    Canevas = draw:add( draw:rect(100, 100, 150, 150, "red"), draw:add(Contour, draw:emptyDrawing(Size, Size))),

    draw:export( print(Canevas, {0, 0, Size, Size}, A, true) ),

    nbPoints(Rect, A, true).

